# std::ios_base Class Reference

Inheritance diagram for std::ios_base:

List of all members.

## Detailed Description

This class defines everything that can be defined about I/O that does not depend on the type of characters being input or output. Most people will only see `ios_base` when they need to specify the full name of the various I/O flags (e.g., the openmodes).

Definition at line 201 of file ios_base.h.

## Public Types

- enum event { erase_event, imbue_event, copyfmt_event }
- typedef void(*) event_callback (event, ios_base &, int)
- typedef _Ios_Fmtflags fmtflags
- typedef int io_state
- typedef _Ios_Iostate iostate
- typedef int open_mode
- typedef _Ios_Openmode openmode
- typedef int seek_dir
- typedef _Ios_Seekdir seekdir
- typedef std::streamoff streamoff
- typedef std::streampos streampos

## Public Member Functions

- const locale & _M_getloc () const
- fmtflags flags (fmtflags __fmtfl)
- fmtflags flags () const
- locale getloc () const
- locale imbue (const locale &__loc)
- long & iword (int __ix)
- streamsize precision (streamsize __prec)
- streamsize precision () const
- void *& pword (int __ix)
- void register_callback (event_callback __fn, int __index)
- fmtflags setf (fmtflags __fmtfl, fmtflags __mask)
- fmtflags setf (fmtflags __fmtfl)
- void unsetf (fmtflags __mask)
- streamsize width (streamsize __wide)
- streamsize width () const
- virtual ~ios_base ()

## Static Public Member Functions

- static bool sync_with_stdio (bool __sync=true)
- static int xalloc () throw ()

## Static Public Attributes

- static const fmtflags adjustfield
- static const openmode app
- static const openmode ate
- static const iostate badbit
- static const fmtflags basefield
- static const seekdir beg
- static const openmode binary
- static const fmtflags boolalpha
- static const seekdir cur
- static const fmtflags dec
- static const seekdir end
- static const iostate eofbit
- static const iostate failbit
- static const fmtflags fixed
- static const fmtflags floatfield
- static const iostate goodbit
- static const fmtflags hex
- static const openmode in
- static const fmtflags internal
- static const fmtflags left
- static const fmtflags oct
- static const openmode out
- static const fmtflags right
- static const fmtflags scientific
- static const fmtflags showbase
- static const fmtflags showpoint
- static const fmtflags showpos
- static const fmtflags skipws
- static const openmode trunc
- static const fmtflags unitbuf
- static const fmtflags uppercase

## Protected Types

- enum { _S_local_word_size }

## Protected Member Functions

- void _M_call_callbacks (event __ev) throw ()
- void _M_dispose_callbacks (void)
- _Words & _M_grow_words (int __index, bool __iword)
- void _M_init ()

## Protected Attributes

- _Callback_list * _M_callbacks
- locale _M_ios_locale
- _Words _M_local_word [_S_local_word_size]
- _Words * _M_word
- int _M_word_size
- _Words _M_word_zero

- iostate _M_exception
- fmtflags _M_flags
- streamsize _M_precision
- iostate _M_streambuf_state
- streamsize _M_width

## Classes

- struct _Callback_list
- struct _Words
- class failure
    These are thrown to indicate problems. Doc me. More...
- class Init

## Member Typedef Documentation

typedef void(*) std::ios_base::event_callback(event, ios_base &, int)

The type of an event callback function.

Parameters:

  | event | One of the members of the event enum.
  | ios_base | Reference to the ios_base object.
  | int | The integer provided when the callback was registered.

Event callbacks are user defined functions that get called during several ios_base and basic_ios functions, specifically imbue(), copyfmt(), and ~ios().

Definition at line 435 of file ios_base.h.

typedef _Ios_Fmtflags std::ios_base::fmtflags

This is a bitmask type.

`"_Ios_Fmtflags"` is implementation-defined, but it is valid to perform bitwise operations on these values and expect the Right Thing to happen. Defined objects of type fmtflags are:

- boolalpha
- dec
- fixed
- hex
- internal
- left
- oct
- right
- scientific
- showbase
- showpoint
- showpos
- skipws
- unitbuf
- uppercase
- adjustfield
- basefield
- floatfield

Definition at line 253 of file ios_base.h.

typedef _Ios_Iostate std::ios_base::iostate

This is a bitmask type.

`"_Ios_Iostate"` is implementation-defined, but it is valid to perform bitwise operations on these values and expect the Right Thing to happen. Defined objects of type iostate are:

- badbit
- eofbit
- failbit
- goodbit

Definition at line 328 of file ios_base.h.

typedef _Ios_Openmode std::ios_base::openmode

This is a bitmask type.

`"_Ios_Openmode"` is implementation-defined, but it is valid to perform bitwise operations on these values and expect the Right Thing to happen. Defined objects of type openmode are:

- app
- ate
- binary
- in
- out
- trunc

Definition at line 359 of file ios_base.h.

typedef _Ios_Seekdir std::ios_base::seekdir

This is an enumerated type.

`"_Ios_Seekdir"` is implementation-defined. Defined values of type seekdir are:

- beg
- cur, equivalent to `SEEK_CUR` in the C standard library.
- end, equivalent to `SEEK_END` in the C standard library.

Definition at line 392 of file ios_base.h.

## Member Enumeration Documentation

enum std::ios_base::event

The set of events that may be passed to an event callback.

erase_event is used during ~ios() and copyfmt(). imbue_event is used during imbue(). copyfmt_event is used during copyfmt().

Definition at line 418 of file ios_base.h.

## Constructor & Destructor Documentation

virtual std::ios_base::~ios_base | ( |  | ) | `[virtual]`

Invokes each callback with erase_event. Destroys local storage.

Note that the ios_base object for the standard streams never gets destroyed. As a result, any callbacks registered with the standard streams will not get invoked with erase_event (unless copyfmt is used).

## Member Function Documentation

const locale& std::ios_base::_M_getloc | ( |  | ) | const`[inline]`

Locale access.

Returns:
  A reference to the current locale.

Like getloc above, but returns a reference instead of generating a copy.

Definition at line 700 of file ios_base.h.

Referenced by std::money_get< _CharT, _InIter >::_M_extract(), std::num_get< _CharT, _InIter >::_M_extract_float(), std::num_get< _CharT, _InIter >::_M_extract_int(), std::time_get< _CharT, _InIter >::_M_extract_name(), std::time_get< _CharT, _InIter >::_M_extract_num(), std::time_get< _CharT, _InIter >::_M_extract_via_format(), std::money_put< _CharT, _OutIter >::_M_insert(), std::num_put< _CharT, _OutIter >::_M_insert_float(), std::num_put< _CharT, _OutIter >::_M_insert_int(), std::__pad< _CharT, _Traits >::_S_pad(), std::money_get< _CharT, _InIter >::do_get(), std::num_get< _CharT, _InIter >::do_get(), std::time_get< _CharT, _InIter >::do_get_date(), std::time_get< _CharT, _InIter >::do_get_monthname(), std::time_get< _CharT, _InIter >::do_get_time(), std::time_get< _CharT, _InIter >::do_get_weekday(), std::time_get< _CharT, _InIter >::do_get_year(), std::time_put< _CharT, _OutIter >::do_put(), std::num_put< _CharT, _OutIter >::do_put(), and std::time_put< _CharT, _OutIter >::put().

fmtflags std::ios_base::flags | ( | fmtflags | __fmtfl | ) | `[inline]`

Setting new format flags all at once.

Parameters:

  | fmtfl | The new flags to set.

Returns:
  The previous format control flags.

This function overwrites all the format flags with fmtfl.

Definition at line 558 of file ios_base.h.

fmtflags std::ios_base::flags | ( |  | ) | const`[inline]`

Access to format flags.

Returns:
  The format control flags for both input and output.

Definition at line 548 of file ios_base.h.

Referenced by std::__ostream_insert(), std::money_get< _CharT, _InIter >::_M_extract(), std::num_get< _CharT, _InIter >::_M_extract_int(), std::money_put< _CharT, _OutIter >::_M_insert(), std::num_put< _CharT, _OutIter >::_M_insert_float(), std::num_put< _CharT, _OutIter >::_M_insert_int(), std::__pad< _CharT, _Traits >::_S_pad(), std::basic_ios< _CharT, _Traits >::copyfmt(), std::num_get< _CharT, _InIter >::do_get(), std::num_put< _CharT, _OutIter >::do_put(), __gnu_cxx::operator<<(), std::tr1::operator<<(), std::basic_ostream< _CharT, _Traits >::operator<<(), and std::tr1::operator>>().

locale std::ios_base::getloc | ( |  | ) | const`[inline]`

Locale access.

Returns:
  A copy of the current locale.

If `imbue(loc)` has previously been called, then this function returns `loc`. Otherwise, it returns a copy of `std::locale()`, the global C++ locale.

Definition at line 690 of file ios_base.h.

Referenced by std::basic_ios< _CharT, _Traits >::copyfmt(), std::money_put< _CharT, _OutIter >::do_put(), std::operator>>(), and std::ws().

locale std::ios_base::imbue | ( | const locale & | __loc | ) |

Setting a new locale.

Parameters:

  | loc | The new locale.

Returns:
  The previous locale.

Sets the new locale for this stream, and then invokes each callback with imbue_event.

Reimplemented in std::basic_ios< _CharT, _Traits >.

Referenced by std::basic_ios< _CharT, _Traits >::imbue().

long& std::ios_base::iword | ( | int | __ix | ) | `[inline]`

Access to integer array.

Parameters:

  | __ix | Index into the array.

Returns:
  A reference to an integer associated with the index.

The iword function provides access to an array of integers that can be used for any purpose. The array grows as required to hold the supplied index. All integers in the array are initialized to 0.

The implementation reserves several indices. You should use xalloc to obtain an index that is safe to use. Also note that since the array can grow dynamically, it is not safe to hold onto the reference.

Definition at line 734 of file ios_base.h.

References std::ios_base::_Words::_M_iword.

streamsize std::ios_base::precision | ( | streamsize | __prec | ) | `[inline]`

Changing flags.

Parameters:

  | prec | The new precision value.

Returns:
  The previous value of precision().

Definition at line 626 of file ios_base.h.

streamsize std::ios_base::precision | ( |  | ) | const`[inline]`

Flags access.

Returns:
  The precision to generate on certain output operations.

Definition at line 618 of file ios_base.h.

Referenced by std::num_put< _CharT, _OutIter >::_M_insert_float(), std::basic_ios< _CharT, _Traits >::copyfmt(), std::operator<<(), and std::operator>>().

void*& std::ios_base::pword | ( | int | __ix | ) | `[inline]`

Access to void pointer array.

Parameters:

  | __ix | Index into the array.

Returns:
  A reference to a void* associated with the index.

The pword function provides access to an array of pointers that can be used for any purpose. The array grows as required to hold the supplied index. All pointers in the array are initialized to 0.

The implementation reserves several indices. You should use xalloc to obtain an index that is safe to use. Also note that since the array can grow dynamically, it is not safe to hold onto the reference.

Definition at line 755 of file ios_base.h.

References std::ios_base::_Words::_M_pword.

void std::ios_base::register_callback | ( | event_callback | __fn,
|  | int | __index |
| ) |  |  |

Add the callback __fn with parameter __index.

Parameters:

  | __fn | The function to add.
  | __index | The integer to pass to the function when invoked.

Registers a function as an event callback with an integer parameter to be passed to the function when invoked. Multiple copies of the function are allowed. If there are multiple callbacks, they are invoked in the order they were registered.

fmtflags std::ios_base::setf | ( | fmtflags | __fmtfl,
|  | fmtflags | __mask |
| ) |  |  | `[inline]`

Setting new format flags.

Parameters:

  | fmtfl | Additional flags to set.
  | mask | The flags mask for fmtfl.

Returns:
  The previous format control flags.

This function clears mask in the format flags, then sets fmtfl `&` mask. An example mask is `ios_base::adjustfield`.

Definition at line 591 of file ios_base.h.

fmtflags std::ios_base::setf | ( | fmtflags | __fmtfl | ) | `[inline]`

Setting new format flags.

Parameters:

  | fmtfl | Additional flags to set.

Returns:
  The previous format control flags.

This function sets additional flags in format control. Flags that were previously set remain set.

Definition at line 574 of file ios_base.h.

Referenced by std::boolalpha(), std::dec(), std::fixed(), std::hex(), std::internal(), std::left(), std::oct(), std::operator<<(), std::operator>>(), std::right(), std::scientific(), std::showbase(), std::showpoint(), std::showpos(), std::skipws(), std::unitbuf(), and std::uppercase().

static bool std::ios_base::sync_with_stdio | ( | bool | __sync = `true` | ) | `[static]`

Interaction with the standard C I/O objects.

Parameters:

  | sync | Whether to synchronize or not.

Returns:
  True if the standard streams were previously synchronized.

The synchronization referred to is only that between the standard C facilities (e.g., stdout) and the standard C++ objects (e.g., cout). User-declared streams are unaffected. See http://gcc.gnu.org/onlinedocs/libstdc++/27_io/howto.html#8 for more.

void std::ios_base::unsetf | ( | fmtflags | __mask | ) | `[inline]`

Clearing format flags.

Parameters:

  | mask | The flags to unset.

This function clears mask in the format flags.

Definition at line 606 of file ios_base.h.

Referenced by std::noboolalpha(), std::noshowbase(), std::noshowpoint(), std::noshowpos(), std::noskipws(), std::nounitbuf(), and std::nouppercase().

streamsize std::ios_base::width | ( | streamsize | __wide | ) | `[inline]`

Changing flags.

Parameters:

  | wide | The new width value.

Returns:
  The previous value of width().

Definition at line 648 of file ios_base.h.

streamsize std::ios_base::width | ( |  | ) | const`[inline]`

Flags access.

Returns:
  The minimum field width to generate on output operations.

"Minimum field width" refers to the number of characters.

Definition at line 640 of file ios_base.h.

Referenced by std::__ostream_insert(), std::money_put< _CharT, _OutIter >::_M_insert(), std::num_put< _CharT, _OutIter >::_M_insert_float(), std::num_put< _CharT, _OutIter >::_M_insert_int(), std::basic_ios< _CharT, _Traits >::copyfmt(), std::num_put< _CharT, _OutIter >::do_put(), __gnu_cxx::operator<<(), std::operator<<(), and std::operator>>().

static int std::ios_base::xalloc | ( |  | ) | throw ()`[static]`

Access to unique indices.

Returns:
  An integer different from all previous calls.

This function returns a unique integer every time it is called. It can be used for any purpose, but is primarily intended to be a unique index for the iword and pword functions. The expectation is that an application calls xalloc in order to obtain an index in the iword and pword arrays that can be used without fear of conflict.

The implementation maintains a static variable that is incremented and returned on each invocation. xalloc is guaranteed to return an index that is safe to use in the iword and pword arrays.

## Member Data Documentation

const fmtflags std::ios_base::adjustfield`[static]`

A mask of left|right|internal. Useful for the 2-arg form of `setf`.

Definition at line 308 of file ios_base.h.

Referenced by std::money_put< _CharT, _OutIter >::_M_insert(), and std::__pad< _CharT, _Traits >::_S_pad().

const openmode std::ios_base::app`[static]`

Seek to end before each write.

Definition at line 362 of file ios_base.h.

const openmode std::ios_base::ate`[static]`

Open and seek to end immediately after opening.

Definition at line 365 of file ios_base.h.

Referenced by std::basic_filebuf< _CharT, _Traits >::open().

const iostate std::ios_base::badbit`[static]`

as an irrecoverable read error from a file).

Definition at line 332 of file ios_base.h.

Referenced by std::basic_istream< _CharT, _Traits >::_M_extract(), std::basic_ostream< _CharT, _Traits >::_M_insert(), std::basic_ostream< _CharT, _Traits >::flush(), std::basic_istream< _CharT, _Traits >::get(), std::getline(), std::basic_istream< _CharT, _Traits >::getline(), std::basic_istream< _CharT, _Traits >::ignore(), std::basic_ios< _CharT, _Traits >::init(), std::operator<<(), std::basic_ostream< _CharT, _Traits >::operator<<(), std::operator>>(), std::basic_istream< _CharT, _Traits >::peek(), std::basic_ostream< _CharT, _Traits >::put(), std::basic_istream< _CharT, _Traits >::putback(), std::basic_istream< _CharT, _Traits >::read(), std::basic_istream< _CharT, _Traits >::readsome(), std::basic_istream< _CharT, _Traits >::seekg(), std::basic_ostream< _CharT, _Traits >::seekp(), std::basic_istream< _CharT, _Traits >::sync(), std::basic_istream< _CharT, _Traits >::tellg(), std::basic_ostream< _CharT, _Traits >::tellp(), std::basic_istream< _CharT, _Traits >::unget(), and std::basic_ostream< _CharT, _Traits >::write().

const fmtflags std::ios_base::basefield`[static]`

A mask of dec|oct|hex. Useful for the 2-arg form of `setf`.

Definition at line 311 of file ios_base.h.

Referenced by std::__int_to_char(), std::num_get< _CharT, _InIter >::_M_extract_int(), std::num_put< _CharT, _OutIter >::_M_insert_int(), std::num_get< _CharT, _InIter >::do_get(), std::num_put< _CharT, _OutIter >::do_put(), and std::basic_ostream< _CharT, _Traits >::operator<<().

const seekdir std::ios_base::beg`[static]`

Request a seek relative to the beginning of the stream.

Definition at line 395 of file ios_base.h.

Referenced by __gnu_cxx::stdio_sync_filebuf< _CharT, _Traits >::seekoff(), __gnu_cxx::stdio_sync_filebuf< _CharT, _Traits >::seekpos(), and std::basic_filebuf< _CharT, _Traits >::seekpos().

const openmode std::ios_base::binary`[static]`

http://gcc.gnu.org/onlinedocs/libstdc++/27_io/howto.html#7 for more.

Definition at line 371 of file ios_base.h.

Referenced by std::basic_filebuf< _CharT, _Traits >::showmanyc().

const fmtflags std::ios_base::boolalpha`[static]`

Insert/extract `bool` in alphabetic rather than numeric format.

Definition at line 256 of file ios_base.h.

Referenced by std::num_get< _CharT, _InIter >::do_get(), and std::num_put< _CharT, _OutIter >::do_put().

const seekdir std::ios_base::cur`[static]`

Request a seek relative to the current position within the sequence.

Definition at line 398 of file ios_base.h.

Referenced by std::basic_filebuf< _CharT, _Traits >::imbue(), std::basic_filebuf< _CharT, _Traits >::pbackfail(), __gnu_cxx::stdio_sync_filebuf< _CharT, _Traits >::seekoff(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekoff(), std::basic_filebuf< _CharT, _Traits >::seekoff(), std::basic_istream< _CharT, _Traits >::tellg(), and std::basic_ostream< _CharT, _Traits >::tellp().

const fmtflags std::ios_base::dec`[static]`

Converts integer input or generates integer output in decimal base.

Definition at line 259 of file ios_base.h.

const seekdir std::ios_base::end`[static]`

Request a seek relative to the current end of the sequence.

Definition at line 401 of file ios_base.h.

Referenced by std::basic_filebuf< _CharT, _Traits >::open(), and std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekoff().

const iostate std::ios_base::eofbit`[static]`

Indicates that an input operation reached the end of an input sequence.

Definition at line 335 of file ios_base.h.

Referenced by std::money_get< _CharT, _InIter >::_M_extract(), std::num_get< _CharT, _InIter >::_M_extract_float(), std::num_get< _CharT, _InIter >::_M_extract_int(), std::num_get< _CharT, _InIter >::do_get(), std::time_get< _CharT, _InIter >::do_get_date(), std::time_get< _CharT, _InIter >::do_get_monthname(), std::time_get< _CharT, _InIter >::do_get_time(), std::time_get< _CharT, _InIter >::do_get_weekday(), std::time_get< _CharT, _InIter >::do_get_year(), std::basic_istream< _CharT, _Traits >::get(), std::getline(), std::basic_istream< _CharT, _Traits >::getline(), std::basic_istream< _CharT, _Traits >::ignore(), std::basic_istream< _CharT, _Traits >::operator>>(), std::operator>>(), std::basic_istream< _CharT, _Traits >::peek(), std::basic_istream< _CharT, _Traits >::read(), std::basic_istream< _CharT, _Traits >::readsome(), and std::ws().

const iostate std::ios_base::failbit`[static]`

desired characters.

Definition at line 340 of file ios_base.h.

Referenced by std::money_get< _CharT, _InIter >::_M_extract(), std::num_get< _CharT, _InIter >::_M_extract_float(), std::num_get< _CharT, _InIter >::_M_extract_int(), std::time_get< _CharT, _InIter >::_M_extract_name(), std::time_get< _CharT, _InIter >::_M_extract_num(), std::time_get< _CharT, _InIter >::_M_extract_via_format(), std::num_get< _CharT, _InIter >::do_get(), std::time_get< _CharT, _InIter >::do_get_monthname(), std::time_get< _CharT, _InIter >::do_get_weekday(), std::time_get< _CharT, _InIter >::do_get_year(), std::basic_istream< _CharT, _Traits >::get(), std::getline(), std::basic_istream< _CharT, _Traits >::getline(), std::basic_ostream< _CharT, _Traits >::operator<<(), std::basic_istream< _CharT, _Traits >::operator>>(), std::operator>>(), std::basic_istream< _CharT, _Traits >::read(), std::basic_istream< _CharT, _Traits >::seekg(), and std::basic_ostream< _CharT, _Traits >::seekp().

const fmtflags std::ios_base::fixed`[static]`

Generate floating-point output in fixed-point notation.

Definition at line 262 of file ios_base.h.

Referenced by std::num_put< _CharT, _OutIter >::_M_insert_float().

const fmtflags std::ios_base::floatfield`[static]`

A mask of scientific|fixed. Useful for the 2-arg form of `setf`.

Definition at line 314 of file ios_base.h.

const iostate std::ios_base::goodbit`[static]`

Indicates all is well.

Definition at line 343 of file ios_base.h.

Referenced by std::basic_istream< _CharT, _Traits >::_M_extract(), std::time_get< _CharT, _InIter >::_M_extract_via_format(), std::basic_ostream< _CharT, _Traits >::_M_insert(), std::time_get< _CharT, _InIter >::do_get_monthname(), std::time_get< _CharT, _InIter >::do_get_weekday(), std::basic_ostream< _CharT, _Traits >::flush(), std::basic_istream< _CharT, _Traits >::get(), std::getline(), std::basic_istream< _CharT, _Traits >::getline(), std::basic_istream< _CharT, _Traits >::ignore(), std::basic_ios< _CharT, _Traits >::init(), std::basic_ostream< _CharT, _Traits >::operator<<(), std::basic_istream< _CharT, _Traits >::operator>>(), std::operator>>(), std::basic_istream< _CharT, _Traits >::peek(), std::basic_ostream< _CharT, _Traits >::put(), std::basic_istream< _CharT, _Traits >::putback(), std::basic_istream< _CharT, _Traits >::read(), std::basic_istream< _CharT, _Traits >::readsome(), std::basic_istream< _CharT, _Traits >::seekg(), std::basic_ostream< _CharT, _Traits >::seekp(), std::basic_istream< _CharT, _Traits >::sync(), and std::basic_istream< _CharT, _Traits >::unget().

const fmtflags std::ios_base::hex`[static]`

Converts integer input or generates integer output in hexadecimal base.

Definition at line 265 of file ios_base.h.

Referenced by std::num_get< _CharT, _InIter >::_M_extract_int(), std::num_put< _CharT, _OutIter >::_M_insert_int(), std::num_get< _CharT, _InIter >::do_get(), std::num_put< _CharT, _OutIter >::do_put(), and std::basic_ostream< _CharT, _Traits >::operator<<().

const openmode std::ios_base::in`[static]`

Open for input. Default for `ifstream` and fstream.

Definition at line 374 of file ios_base.h.

Referenced by std::basic_stringbuf< _CharT, _Traits, _Alloc >::_M_sync(), std::basic_filebuf< _CharT, _Traits >::pbackfail(), std::basic_istream< _CharT, _Traits >::seekg(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekoff(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekpos(), std::basic_filebuf< _CharT, _Traits >::showmanyc(), std::basic_istream< _CharT, _Traits >::tellg(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::underflow(), std::basic_filebuf< _CharT, _Traits >::underflow(), and std::basic_filebuf< _CharT, _Traits >::xsgetn().

const fmtflags std::ios_base::internal`[static]`

designated.

Definition at line 270 of file ios_base.h.

Referenced by std::money_put< _CharT, _OutIter >::_M_insert(), std::__pad< _CharT, _Traits >::_S_pad(), and std::num_put< _CharT, _OutIter >::do_put().

const fmtflags std::ios_base::left`[static]`

generated output. (I.e., the thing you print is flush left.)

Definition at line 274 of file ios_base.h.

Referenced by std::money_put< _CharT, _OutIter >::_M_insert(), std::__pad< _CharT, _Traits >::_S_pad(), and __gnu_cxx::operator<<().

const fmtflags std::ios_base::oct`[static]`

Converts integer input or generates integer output in octal base.

Definition at line 277 of file ios_base.h.

Referenced by std::__int_to_char(), std::num_get< _CharT, _InIter >::_M_extract_int(), std::num_put< _CharT, _OutIter >::_M_insert_int(), and std::basic_ostream< _CharT, _Traits >::operator<<().

const openmode std::ios_base::out`[static]`

Open for output. Default for `ofstream` and fstream.

Definition at line 377 of file ios_base.h.

Referenced by std::basic_stringbuf< _CharT, _Traits, _Alloc >::_M_sync(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::overflow(), std::basic_filebuf< _CharT, _Traits >::overflow(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekoff(), std::basic_ostream< _CharT, _Traits >::seekp(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekpos(), std::basic_ostream< _CharT, _Traits >::tellp(), and std::basic_filebuf< _CharT, _Traits >::xsputn().

const fmtflags std::ios_base::right`[static]`

generated output. (I.e., the thing you print is flush right.)

Definition at line 281 of file ios_base.h.

const fmtflags std::ios_base::scientific`[static]`

Generates floating-point output in scientific notation.

Definition at line 284 of file ios_base.h.

const fmtflags std::ios_base::showbase`[static]`

output.

Definition at line 288 of file ios_base.h.

Referenced by std::money_get< _CharT, _InIter >::_M_extract(), std::money_put< _CharT, _OutIter >::_M_insert(), std::num_put< _CharT, _OutIter >::_M_insert_int(), and std::num_put< _CharT, _OutIter >::do_put().

const fmtflags std::ios_base::showpoint`[static]`

floating-point output.

Definition at line 292 of file ios_base.h.

const fmtflags std::ios_base::showpos`[static]`

Generates a + sign in non-negative generated numeric output.

Definition at line 295 of file ios_base.h.

Referenced by std::num_put< _CharT, _OutIter >::_M_insert_int().

const fmtflags std::ios_base::skipws`[static]`

Skips leading white space before certain input operations.

Definition at line 298 of file ios_base.h.

const openmode std::ios_base::trunc`[static]`

Open for input. Default for `ofstream`.

Definition at line 380 of file ios_base.h.

const fmtflags std::ios_base::unitbuf`[static]`

Flushes output after each output operation.

Definition at line 301 of file ios_base.h.

const fmtflags std::ios_base::uppercase`[static]`

in generated output.

Definition at line 305 of file ios_base.h.

Referenced by std::__int_to_char(), std::num_put< _CharT, _OutIter >::_M_insert_int(), and std::num_put< _CharT, _OutIter >::do_put().

The documentation for this class was generated from the following file:

- ios_base.h